/*************************************
	
	File: ShapeMeasurement.h
	
	Header file for calling accurate shape measurement
	routines.
	
	
**************************************/

#include "GXTypes.h"


gxPoint* AccurateShapeLengthToPoint(gxShape target, long index, Fixed length, gxPoint *location, gxPoint *tangent);
wide *AccurateGetShapeLength(gxShape target, long index, wide *result);
void AccuratePrimitiveShape(gxShape target);


#define FixedToDouble(x) ( (long)(x) / 65536.0 )
#define DoubleToFixed(x) ( (long)( x * 65536.0 ) )

typedef struct {
	
	double x;
	double y;
	
} dblPoint;
