// PlatformMemory.cp 
// Copyright  1985-96 by Apple Computer, Inc. All rights reserved.

#ifndef PLATFORMMEMORY_H
#include "PlatformMemory.h"
#endif

// MacApp

#ifndef __UMACAPPUTILITIES__
#include "UMacAppUtilities.h"
#endif

#ifndef __UMEMORY__
#include "UMemory.h"
#endif

// ANSI

#ifndef __STDIO__
#include <stdio.h>
#endif

short gOHRemainingIncrements = 3;
//----------------------------------------------------------------------------------------
// PlatformAllocateBlock
//----------------------------------------------------------------------------------------
#pragma segment MAMemoryRes

void *PlatformAllocateBlock(size_t size)
{
	Boolean heapPerm;

	if (gUMemoryInitialized)
		heapPerm = PermAllocation(TRUE);
	
	void *ptr = NULL;												//added by C. Kopala 6/21/96
	//void *ptr = NewPtr(size);							//commented out by C. Kopala 6/21/96
	if (gOHRemainingIncrements > 0)					//added by by C. Kopala 6/21/96
		{																			//added by by C. Kopala 6/21/96
			ptr = NewPtr(size);									//added by by C. Kopala 6/21/96
			gOHRemainingIncrements--;						//added by by C. Kopala 6/21/96
		}																			//added by by C. Kopala 6/21/96
		
	if (gUMemoryInitialized)
		PermAllocation(heapPerm);		// Reset perm flag before possible Failure
	
	FailNIL(ptr);
		
	return ptr;
}

//----------------------------------------------------------------------------------------
// PLATFORM_ASSERT
//----------------------------------------------------------------------------------------
#pragma segment MAMemoryRes

void PLATFORM_ASSERT(Boolean condition)
{
	if (!condition)
		ProgramBreak("Assertion failed.");
}

//----------------------------------------------------------------------------------------
// PLATFORM_PRINT_STRING
//----------------------------------------------------------------------------------------
#pragma segment MAMemoryRes

void PLATFORM_PRINT_STRING(const char* string)
{
#if qDebugMsg
	fprintf(stderr, string);
#else
	ProgramBreak(string);
#endif
}

//----------------------------------------------------------------------------------------
// End of PlatformMemory.cp

#pragma segment Inline
